#ifndef WSQ_DEMO_H_
#define WSQ_DEMO_H_

//Defined controls IDs (no .rc file)
#define BTN_CONVERT			1
#define BTN_OPEN			2
#define BTN_SAVE			3
#define BTN_REGISTER		4
#define IMG_BITMAP			5
#define BTN_DECODE			6
#define BTN_ENCODE			7

const wchar_t* g_szWsqClass = L"WSQClass";
HINSTANCE g_hInstance = 0;
HWND g_hwnd = 0;
HWND g_bitmapWnd = 0;
HWND g_hwndSaveButton = 0;
HWND g_hwndDecodeButton = 0;
HBITMAP g_hBitmap = 0;
BITMAP g_pic;

int input_stream_length = 0;
int output_stream2_length = 0;
unsigned char* input_data_stream = 0;
unsigned char* output_data_stream = 0;
unsigned char* input_data_stream2 = 0;
unsigned char* output_data_stream2 = 0;
int g_width = 0;
int g_height = 0;
int g_ppi = 0;
char* g_comment_text = 0; //need to initialize comment_text in order to avoid crashing
char* g_comment_text2 = 0; //need to initialize comment_text in order to avoid crashing

HINSTANCE g_wsqLibrary = 0;

typedef int (WINAPI *RegisterWSQ)();
typedef HBITMAP (WINAPI *CreateBMPFromFile)(const char *filename);
typedef void (WINAPI *SaveBMPToFile)(HBITMAP hBitmap, const char *filename, int filetype);
typedef HBITMAP (WINAPI *CreateBMPFromWSQByteArray)(unsigned char *input_wsq_byte_array, int size_of_input_wsq_byte_array);
typedef int (WINAPI *SaveWSQByteArrayToImageFile)(unsigned char *input_wsq_byte_array, int size_of_input_wsq_byte_array, const char *filename, int filetype);
typedef int (WINAPI *WSQ_decode_stream)(unsigned char *input_data_stream, const int input_stream_length, unsigned char **output_data_stream, int *width, int *height, int *ppi, char **comment_text);
typedef int (WINAPI *WSQ_encode_stream)(unsigned char *input_data_stream, const int width, const int height, const double bitrate, const int ppi, char *comment_text, unsigned char **output_data_stream, int *output_stream_length);
typedef int (WINAPI *ShowFileConverter)();
typedef HBITMAP (WINAPI *ConvertHBITMAPtoGrayScale256)(HBITMAP hBitmap);
typedef int (WINAPI *SaveHBITMAPtoFileAsGrayScale256BMP)(HBITMAP hBitmap, const char *filename);




RegisterWSQ RegisterWSQ_ptr = 0;
CreateBMPFromFile CreateBMPFromFile_ptr = 0;
SaveBMPToFile SaveBMPToFile_ptr = 0;
CreateBMPFromWSQByteArray CreateBMPFromWSQByteArray_ptr = 0;
SaveWSQByteArrayToImageFile SaveWSQByteArrayToImageFile_ptr = 0;
WSQ_decode_stream WSQ_decode_stream_ptr = 0;
WSQ_encode_stream WSQ_encode_stream_ptr = 0;
ShowFileConverter ShowFileConverter_ptr = 0;
ConvertHBITMAPtoGrayScale256 ConvertHBITMAPtoGrayScale256_ptr = 0;
SaveHBITMAPtoFileAsGrayScale256BMP SaveHBITMAPtoFileAsGrayScale256BMP_ptr = 0;


bool loadWsqLibrary();
void registerWsq();
void showFileConverter();
void saveFile();
void loadFile();
void decodeStream();
void encodeStream();

LRESULT CALLBACK WndProc( HWND hWnd , UINT message , WPARAM wParam , LPARAM lParam);

#endif /*WSQ_DEMO_H_*/
